<?php
/**
 * InlineObject2
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject2 Class Doc Comment
 *
 * @category Class
 * @description This object is used to get phone calls based on this filter settings
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject2 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_2';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'timeframe' => '\SLIS\Adapter\Tanss\Model\InlineObject2Timeframe',
        'showTrysAsWell' => 'bool',
        'numberFilters' => 'string[]',
        'employeeId' => 'int',
        'companyId' => 'int',
        'numberInfos' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'timeframe' => null,
        'showTrysAsWell' => null,
        'numberFilters' => null,
        'employeeId' => null,
        'companyId' => null,
        'numberInfos' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timeframe' => 'timeframe',
        'showTrysAsWell' => 'showTrysAsWell',
        'numberFilters' => 'numberFilters',
        'employeeId' => 'employeeId',
        'companyId' => 'companyId',
        'numberInfos' => 'numberInfos'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timeframe' => 'setTimeframe',
        'showTrysAsWell' => 'setShowTrysAsWell',
        'numberFilters' => 'setNumberFilters',
        'employeeId' => 'setEmployeeId',
        'companyId' => 'setCompanyId',
        'numberInfos' => 'setNumberInfos'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timeframe' => 'getTimeframe',
        'showTrysAsWell' => 'getShowTrysAsWell',
        'numberFilters' => 'getNumberFilters',
        'employeeId' => 'getEmployeeId',
        'companyId' => 'getCompanyId',
        'numberInfos' => 'getNumberInfos'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timeframe'] = $data['timeframe'] ?? null;
        $this->container['showTrysAsWell'] = $data['showTrysAsWell'] ?? null;
        $this->container['numberFilters'] = $data['numberFilters'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['numberInfos'] = $data['numberInfos'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timeframe
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineObject2Timeframe|null
     */
    public function getTimeframe()
    {
        return $this->container['timeframe'];
    }

    /**
     * Sets timeframe
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineObject2Timeframe|null $timeframe timeframe
     *
     * @return self
     */
    public function setTimeframe($timeframe)
    {
        $this->container['timeframe'] = $timeframe;

        return $this;
    }

    /**
     * Gets showTrysAsWell
     *
     * @return bool|null
     */
    public function getShowTrysAsWell()
    {
        return $this->container['showTrysAsWell'];
    }

    /**
     * Sets showTrysAsWell
     *
     * @param bool|null $showTrysAsWell if true, will show \"tries\" as well, meaning phone calls which didn't have an established connection
     *
     * @return self
     */
    public function setShowTrysAsWell($showTrysAsWell)
    {
        $this->container['showTrysAsWell'] = $showTrysAsWell;

        return $this;
    }

    /**
     * Gets numberFilters
     *
     * @return string[]|null
     */
    public function getNumberFilters()
    {
        return $this->container['numberFilters'];
    }

    /**
     * Sets numberFilters
     *
     * @param string[]|null $numberFilters one or more telephone number filters to be applied to the list
     *
     * @return self
     */
    public function setNumberFilters($numberFilters)
    {
        $this->container['numberFilters'] = $numberFilters;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId only shows phone calls of a certain employee
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId only shows phone calls of these companies
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets numberInfos
     *
     * @return bool|null
     */
    public function getNumberInfos()
    {
        return $this->container['numberInfos'];
    }

    /**
     * Sets numberInfos
     *
     * @param bool|null $numberInfos if true, then the fields \"fromPhoneNrInfos\" and \"toPhoneNrInfos\" will be determined for the calls
     *
     * @return self
     */
    public function setNumberInfos($numberInfos)
    {
        $this->container['numberInfos'] = $numberInfos;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


